#include <hmg.ch>
#include "hmg_hpdf.ch"

Function Main

   define window main at 0, 0 width 300 height 300 main title 'HMG HPDF Sample'
      define button print
         row 100
         col 100
         caption 'Create PDF'
         action pdf_create()
      end button
   end window
   main.center
   main.activate

Return

function pdf_create
   local lSuccess := .f.
   SELECT HPDFDOC 'sample.pdf' TO lSuccess papersize HPDF_PAPER_A4  ORIENTATION HPDF_ORIENT_LANDSCAPE
   SET HPDFDOC COMPRESS ALL
   SET HPDFDOC PAGEMODE TO OUTLINE
//   SET HPDFDOC PASSWORD OWNER 'owner' USER 'user'
   if lSuccess
      START HPDFDOC
         SET HPDFDOC ROOTOUTLINE TITLE "Index" NAME "IndexName"
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 1' PARENT "IndexName"
            @ 10, 60 HPDFPRINT 'This is sample Left Aligned' 
            @ 15, 20 HPDFPRINT 'This is sample Red Colored' color { 255, 0, 0 }
            @ 15, 100 HPDFPRINT 'This is sample Another Fantastic Color' color { 150, 100, 100 }         
            @ 20, 60 HPDFPRINT 'This is sample Center Aligned' CENTER
            @ 25, 60 HPDFPRINT 'This is sample Right Aligned' RIGHT
            @ 30, 10 HPDFPRINT 'This is a small paragraph to be printed inside a rectangular area which is left aligned.' to 50, 60 
            @ 60, 10 HPDFPRINT 'This is a small paragraph to be printed inside a rectangular area which is center aligned.' to 80, 60 CENTER
            @ 90, 10 HPDFPRINT 'This is a small paragraph to be printed inside a rectangular area which is right aligned.' to 110, 60 RIGHT
            @ 120, 10 HPDFPRINT 'This is a small paragraph to be printed inside a rectangular area which is justify aligned.' to 140, 60 JUSTIFY
            @ 150, 10 HPDFPRINT line to 160, 10
            @ 150, 20 HPDFPRINT line to 160, 20 penwidth 0.5
            @ 150, 30 HPDFPRINT line to 160, 30 penwidth 1 color { 0, 255, 0 }
         END HPDFPAGE
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 2'
            @ 10, 60 HPDFPRINT 'This is Page 2' 
            @ 30, 20 HPDFPRINT rectangle to 60, 50
            @ 40, 30 HPDFPRINT rectangle to 50, 40 penwidth 1 color { 0, 255, 0 }
            @ 70, 20 HPDFPRINT rectangle to 90, 40 penwidth 1 color { 0, 255, 0 } filled
            @ 100, 10 HPDFPRINT 'This is text in BIG size' size 30
            @ 120, 10 HPDFPRINT 'This is in Times-Roman font' font 'Times-Roman' size 18
            @ 140, 10 HPDFPRINT 'This is in Courier-BoldOblique font' font 'Courier-BoldOblique' size 18
            @ 160, 10 HPDFPRINT 'This is in Times-Italic font' font 'Times-Italic' size 18
            @ 180, 10 HPDFPRINT 'This is in Helvetica-Bold font' font 'Helvetica-Bold' size 18
            @ 200, 10 HPDFPRINT 'This is in Courier font' font 'Courier' size 18
         END HPDFPAGE
         SET HPDFDOC ROOTOUTLINE TITLE "New Index" NAME "IndexNew"
         SET HPDFDOC ROOTOUTLINE TITLE "Sub Index of New Index" NAME "IndexSub" PARENT "IndexNew"
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 3' NAME "Page3" PARENT "IndexSub" 
            @ 10, 60 HPDFPRINT 'This is Page 3' 
            @ 20, 10 HPDFPRINT IMAGE 'peacock.png' width 140 height 106
            @ 17, 07 HPDFPRINT rectangle to 129, 153 penwidth 2 color { 0, 0, 255 }         
         END HPDFPAGE
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 4' PARENT "Page3"
            @ 20, 20 HPDFPRINT CIRCLE RADIUS 20
            @ 20, 45 HPDFPRINT CIRCLE RADIUS 10 color { 0, 255, 0 } 
            @ 20, 70 HPDFPRINT CIRCLE RADIUS 10 color { 255, 255, 0 } filled
            @ 50, 20 HPDFPRINT ARC RADIUS 10 ANGLE FROM 0 TO 180 penwidth 2 color { 255, 0, 255 }
            @ 50, 50 HPDFPRINT ELLIPSE HORIZONTAL RADIUS 10 VERTICAL RADIUS 20 penwidth 2 color { 255, 0, 255 }
            @ 50, 90 HPDFPRINT ELLIPSE HORIZONTAL RADIUS 20 VERTICAL RADIUS 10 penwidth 2 color { 0, 0, 255 }
            @ 50, 140 HPDFPRINT ELLIPSE HORIZONTAL RADIUS 20 VERTICAL RADIUS 10 penwidth 2 color { 0, 0, 255 } filled
            // try rounded rectangle
            @ 100, 70 HPDFPRINT CURVE FROM 70, 70 TO 70, 100
            @ 70, 200 HPDFPRINT CURVE FROM 70, 230 TO 100, 230
            @ 150, 70 HPDFPRINT CURVE FROM 180, 70 TO 180, 100
            @ 180, 200 HPDFPRINT CURVE FROM 180, 230 TO 150, 230
            @ 70, 100 HPDFPRINT LINE TO 70, 200
            @ 100, 70 HPDFPRINT LINE TO 150, 70
            @ 100, 230 HPDFPRINT LINE TO 150, 230
            @ 180, 100 HPDFPRINT LINE TO 180, 200
         END HPDFPAGE
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 5' 
            SET HPDFDOC PAGEOUTLINE TITLE 'Page 5' PARENT "IndexName"
            @ 10, 10 HPDFPRINT RECTANGLE TO 50, 50 rounded
            @ 10, 60 HPDFPRINT RECTANGLE TO 90, 90 color { 255, 0, 0 } penwidth 2 rounded curve 10
            @ 100, 100 HPDFPRINT RECTANGLE TO 150, 200 color { 0, 0, 255 } filled rounded curve 25
         END HPDFPAGE
         START HPDFPAGE
            SET HPDFDOC PAGEOUTLINE TITLE 'Icon Tooltip' 
            @ 10, 10 HPDFTOOLTIP 'This is Comment Icon Tooltip' ICON COMMENT
            @ 20, 10 HPDFTOOLTIP 'This is Key Icon Tooltip' ICON KEY
            @ 30, 10 HPDFTOOLTIP 'This is Note Icon Tooltip' ICON NOTE
            @ 40, 10 HPDFTOOLTIP 'This is Help Icon Tooltip' ICON HELP
            @ 50, 10 HPDFTOOLTIP 'This is New_Paragraph Icon Tooltip' ICON NEW_PARAGRAPH
            @ 60, 10 HPDFTOOLTIP 'This is Paragraph Icon Tooltip' ICON PARAGRAPH
            @ 70, 10 HPDFTOOLTIP 'This is Insert Icon Tooltip' ICON INSERT
         END HPDFPAGE
         INSERT HPDFPAGE BEFORE PAGE 1
            @ 10, 10 HPDFPAGELINK 'Go to Page 1' TO 2 size 12 color { 255, 0, 0 }
            @ 20, 10 HPDFPAGELINK 'Go to Page 2' TO 3 size 12 color { 255, 0, 0 } BORDER
            @ 30, 10 HPDFPAGELINK 'Go to Page 3' TO 4 size 12 color { 255, 0, 0 } BORDER WIDTH 0.5
            @ 40, 10 HPDFPAGELINK 'Go to Page 4' TO 5 font 'Times-Roman' size 12 color { 255, 0, 0 }
            @ 50, 10 HPDFPAGELINK 'Go to Page 5' TO 6 size 12 color { 255, 0, 0 }
            @ 60, 10 HPDFPAGELINK 'Go to Page 6' TO 7 size 12 color { 255, 0, 0 }
            @ 70, 10 HPDFURLLINK "Click here to go to HMGForum" TO 'http://www.hmgforum.com' SIZE 14 COLOR { 0, 0, 255 }
         END HPDFPAGE
         SELECT HPDFPAGE 4
            @ 180, 30 HPDFPRINT 'This is included in the last minute!'
         END HPDFPAGE
         msginfo( 'There are totally ' + alltrim( str( HMG_HPDF_PageCount() ) ) + ' pages in this PDF Doc' )
      END HPDFDOC
   endif   
   execute file 'sample.pdf'      
   
return nil